###################################################
# Kernel (module Manager) for Spectra
# (c) 1998 -reflux- reflux@europa.com
###################################################

## kernel version
@kernelver=[98711]
#module update
#exec rm ~/.spectra/etc/kernel.data/data.spc
#exec ls -q -1 ~/.spectra/etc/kernel.data/init >~/.spectra/etc/kernel.data/data.spc
@spectra.ver=[1.0r14]
fset format_version $0 + Spectra v $spectra.ver  By Reflux
## system variables
@AUP=[\[A]
@ADN=[\[B]
@ART=[\[C]
@ALT=[\[D]
@BLNK=[\[5m]
@CL=[\[0m]
@BLU=[\[0;34m]
@MAG=[\[0;35m]
@CYN=[\[0;36m]
@WHT=[\[0;37m]
@RED=[\[0;31m]
@GRN=[\[0;32m]
@YEL=[\[0;33m]
@BLK=[\[0;30m]
@HBLK=[\[1;30m]
@HGRN=[\[1;32m]
@HBLU=[\[1;34m]
@HMAG=[\[1;35m]
@HCYN=[\[1;36m]
@HWHT=[\[1;37m]
@HRED=[\[1;31m]
@HGRN=[\[1;32m]
@HYEL=[\[1;33m]
@BBLU=[\[44m]
@BBLK=[\[40m]
@BRED=[\[41m]
@BGRN=[\[42m]
@BYEL=[\[43m]
@BBLU=[\[44m]
@BMAG=[\[45m]
@BCYN=[\[46m]
@BWHT=[\[47m]
@BG=[\[44m]

## Kernel data

alias kecho { 
echo ${HWHT}-${HGRN}SPECTRA-KERNEL${HWHT}- $0- 
}

alias kpause {
if ([$0] != []) {
@xone=[0]
	while ([$xone] <= [$0]) {
		@xone++
	}
} {
kecho ERROR: Usage kpause integer, (Spectra Kernel Command)
}
}


alias addmod {
if ([$0] != []) {
if ( fexist( ~/.spectra/modules/$0.mod) == [1] ) {
        exec cp ~/.spectra/modules/$0.mod.init ~/.spectra/etc/kernel.data/init/$0.init
	exec cp ~/.spectra/modules/$0.mod.desc ~/.spectra/etc/kernel.data/$0.desc
	exec touch ~/.spectra/etc/kernel.data/modlist/$0
        exec ls -q -1 ~/.spectra/etc/kernel.data/init >~/.spectra/etc/kernel.data/data.spc
	kpause 5000
	reloadmods
        }

}{
kecho ERROR: you just tried to add a non-existant module.
kecho `----> Please verify that the module is in ~/.spectra/modules, and try again
}
}{
echo ${HGRN}USAGE:${HWHT} /addmod [modfilename] (with out .mod)
echo ${HGRN}`---->${HWHT} the mod file must be in ~/.spectra/modules
}


alias remmod {
if ([$0] != []) {
@z=[0]
@zz=[0]
        if ( fexist( ~/.spectra/etc/kernel.data/init/$0.init ) == [-1] )
        {
        kecho ${HWHT}-${HBLU}ERROR: Module, $0, not found${HWHT}-
        } {
        unload ~/.spectra/etc/kernel.data/$0.init
	exec rm ~/.spectra/etc/kernel.data/init/$0.init
	exec rm ~/.spectra/etc/kernel.data/$0.desc
	exec rm ~/.spectra/etc/kernel.data/modlist/$0
	load ~/.spectra/spectra.irc
	kecho ${HWHT}-${HBLU}Module $0 Has been removed, and the kernel has been reloaded${HWHT}-        
	}
        @z++
        } {

echo ${HGRN}USAGE:${HWHT} /remmod [module name]
echo ${HGRN}`---->${HWHT} removes a modfile from the kernel boot scripts '/modlist' for a list of loaded mods'
}
}

alias modlist {
exec -name modlist exec ls -q -1 ~/.spectra/etc/kernel.data/modlist
}

alias reloadmods {
^exec ls -q -1 --color=never ~/.spectra/etc/kernel.data/init >~/.spectra/etc/kernel.data/data.spc
@instr1=[]
@fileh=[]
@fileh=open(~/.spectra/etc/kernel.data/data.spc R)
while (!eof(${fileh})) {
	@instr1=read(${fileh})
	load ~/.spectra/etc/kernel.data/init/${instr1}
}
	@close(${fileh})

kecho Kernel loaded
}




## This code was borrowed from EDK By TimeCop
^on -ctcp "*" {
if ([$2]==[spectra]) { ^timer 1 ^quote NOTICE $0 :SPECTRA ${spectra.ver} By Reflux }
}
## End
on ^exec "modlist *" {
echo $cparse("%n\[%gmodule list%n\] $1-")
#kecho $1-
}

reloadmods

if ( fexist( ~/.spectra/etc/krndata ) != [-1] ) {
# reloadmods
^exec rm ~/.spectra/etc/krndata
}{
^exec touch ~/.spectra/etc/krndata
}

alias spectra load ~/.spectra/spectra.irc

if ([$kernel_loaded] == [0]) {
spectra
}
#spectra
